//
//  NEXLocationCluster.h
//  NumberEightCompiled
//
//  Created by Oliver Kocsis on 19/06/2018.
//  Copyright © 2018 NumberEight Technologies Ltd. All rights reserved.
//
#pragma once

#import "NEClusterID.h"
#import "NELocationCluster.h"
#import "NEXSensorItem.h"

NS_ASSUME_NONNULL_BEGIN

/**
 * Represents a location cluster, comprising a centroid location and cluster ID.
 */
@interface NEXLocationCluster : NEXSensorItem

/**
 * Default constructor.
 */
- (instancetype)init;

/**
 * Default constructor.
 */
+ (instancetype)new;

/**
 * Conversion copy constructor.
 * @param locationCluster NELocationCluster to copy from.
 */
- (instancetype)initWithLocationCluster:(NELocationCluster)locationCluster;

/**
 * Conversion copy contructor.
 * @param locationCluster NELocationCluster to copy from.
 * @param confidence An optional confidence level from 0.0 (min) to 1.0 (max).
 */
- (instancetype)initWithLocationCluster:(NELocationCluster)locationCluster
                             confidence:(double)confidence;

/**
 * @param centroid The centroid location of the cluster.
 * @param clusterID The ID of the cluster, or designation as 'noise' if < 0.
 */
- (instancetype)initWithCentroid:(NELocationCoordinate2D)centroid clusterID:(int32_t)clusterID;

/**
 * @param centroid The centroid location of the cluster.
 * @param clusterID The ID of the cluster, or designation as 'noise' if < 0.
 * @param confidence An optional confidence level from 0.0 (min) to 1.0 (max).
 */
- (instancetype)initWithCentroid:(NELocationCoordinate2D)centroid
                       clusterID:(int32_t)clusterID
                      confidence:(double)confidence;

/**
 * Parse a string in serialized form.
 * @param string The serialized string, as generated by serialize()
 *
 * @return `nil` if unserialization failed.
 */
+ (instancetype _Nullable)unserializeWithString:(NSString*)string;

@property(nonatomic, readonly) NELocationCluster value DEPRECATED_ATTRIBUTE;

/**
 * The center of the location cluster, represented with a latitude and longitude.
 */
@property(nonatomic, readwrite) NELocationCoordinate2D centroid;

/**
 * Latitude in decimal degrees.
 */
@property(nonatomic, readwrite) double latitude;

/**
 * Longitude in decimal degrees.
 */
@property(nonatomic, readwrite) double longitude;

/**
 * The ID for this cluster.
 * Clusters with the same ID are semantically equal.
 */
@property(nonatomic, readwrite) int32_t clusterID;

/**
 * Returns true if the provided object is semantically equivalent, according to the
 * isSemanticallyEqual C function, false otherwise.
 *
 * @see NELocationCluster_isSemanticallyEqual
 *
 * @param object Value to compare with.
 */
- (BOOL)semanticEquals:(id _Nullable)object;

- (double)distanceToCluster:(NEXLocationCluster*)cluster;

/**
 * @return A hash value representing the state of the Type.
 *          Can be used for checking equality.
 */
@property(nonatomic, readonly) NSUInteger hash;

/**
 * @return The name of the concrete value class extending NEXSensorItem.
 */
@property(nonatomic, readonly) NSString* type;

/**
 * @return A human-readable format of the held data.
 */
@property(nonatomic, readonly) NSString* description;

/**
 * @return A machine-readable format of the held data.  Returns `nil` if @p type is invalid, or if
 * serialization failed.
 */
- (NSString* _Nullable)serialize;

/**
 * Strict equality comparison.
 *
 * @see NELocationCluster_isEqual
 *
 * @param object Value to compare with.
 */
- (BOOL)isEqual:(id _Nullable)object;

/**
 * Convert the Objective-C class to a C-compatible struct.
 */
- (NELocationCluster)c_val;

@end
NS_ASSUME_NONNULL_END
